Package org.bukkit.block.data

# Enum Class Rail.Shape

java.lang.Object
java.lang.Enum<Rail.Shape>
org.bukkit.block.data.Rail.Shape

All Implemented Interfaces:
  `Serializable`, `Comparable<Rail.Shape>`, `Constable`

Enclosing interface:
  Rail

public static enum Rail.Shape extends Enum<Rail.Shape>
The different types of shapes a rail block can occupy.

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`ASCENDING_EAST`
The rail ascends in the east (positive X) direction.
`ASCENDING_NORTH`
The rail ascends in the north (negative Z) direction.
`ASCENDING_SOUTH`
The rail ascends in the south (positive Z) direction.
`ASCENDING_WEST`
The rail ascends in the west (negative X) direction.
`EAST_WEST`
The rail runs flat along the east/west (X) axis.
`NORTH_EAST`
The rail forms a curve connecting the north and east faces of the block.
`NORTH_SOUTH`
The rail runs flat along the north/south (Z) axis.
`NORTH_WEST`
The rail forms a curve connecting the north and west faces of the block.
`SOUTH_EAST`
The rail forms a curve connecting the south and east faces of the block.
`SOUTH_WEST`
The rail forms a curve connecting the south and west faces of the block.

## Method Summary

Modifier and Type
Method
Description
`static Rail.Shape`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static Rail.Shape[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### NORTH_SOUTH

public static final Rail.Shape NORTH_SOUTH
The rail runs flat along the north/south (Z) axis.

### EAST_WEST

public static final Rail.Shape EAST_WEST
The rail runs flat along the east/west (X) axis.

### ASCENDING_EAST

public static final Rail.Shape ASCENDING_EAST
The rail ascends in the east (positive X) direction.

### ASCENDING_WEST

public static final Rail.Shape ASCENDING_WEST
The rail ascends in the west (negative X) direction.

### ASCENDING_NORTH

public static final Rail.Shape ASCENDING_NORTH
The rail ascends in the north (negative Z) direction.

### ASCENDING_SOUTH

public static final Rail.Shape ASCENDING_SOUTH
The rail ascends in the south (positive Z) direction.

### SOUTH_EAST

public static final Rail.Shape SOUTH_EAST
The rail forms a curve connecting the south and east faces of the block.

### SOUTH_WEST

public static final Rail.Shape SOUTH_WEST
The rail forms a curve connecting the south and west faces of the block.

### NORTH_WEST

public static final Rail.Shape NORTH_WEST
The rail forms a curve connecting the north and west faces of the block.

### NORTH_EAST

public static final Rail.Shape NORTH_EAST
The rail forms a curve connecting the north and east faces of the block.

## Method Details

### values

public static Rail.Shape[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static Rail.Shape valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null